package mathx;

/**
 * Simple array utilities that seem to be missing from haxe...?
 */
class ArrayUtil
{

	/**
	 * Does a deep copy on the array, assuming the items are
	 * further arrays or have "copy" semantics (such as fundamentals)
	 */
	/*static public function deepCopy( arr : Array<T> ) : Array<T>
	{
		var r = new Array<T>();
		for( i in 0...arr.length )
		{
			if( Std.is( arr[i], Array<T> ) )	//embedded array...
				r.push( deepCopy( arr[i] ) );
			else
				r.push( arr[i].copy() );
		}
		
		return r;
	}*/


	/**
	 * Compares the arrays for equality
	 */
	static public function equals<T>( a : Array<T>, b : Array<T> ) : Bool
	{
		if( a.length != b.length )
			return false;
			
		for( i in 0...a.length )
			if( a[i] != b[i] )
				return false;
				
		return true;
	}
	
	/**
	 * Randomizes the order of the elements in the array
	 */
	static public function shuffle<T>( a : Array<T> ) : Array<T>
	{
		var c = a.copy();
		for( i in 0...c.length )
		{
			var t = c[i];
			var ndx = Math.floor( Math.random() * c.length );
			Assert.isTrue( ndx >= 0 && ndx < c.length );	//I don't have docs for Random...
			c[i] = c[ ndx ];
			c[ndx] = t;
		}
		return c;
	}	 
	
	/**
	 * Creates a set of numbers in increasing order.  (haxe syntax doesn't
	 * allow this be to any numeric, Float or Int)
	 */
	static public function incList( start : Int, num : Int ) : Array<Int>
	{
		var a = new Array<Int>();
		for( i in 0...num )
			a.push( i + start );
		return a;
	}	 
}
