package mathx;

class MatPoint extends MPoint<Int>
{
	private function new( ax : Int, ay : Int )
	{
		x = ax;
		y = ay;
	}
	
	static public function at( ax : Int, ay : Int) : MatPoint
	{
		return new MatPoint( ax, ay );
	}
	
	public function equals( mp : MatPoint ) : Bool
	{
		return x == mp.x && y == mp.y;
	}
	
	public function copy() : MatPoint
	{
		return new MatPoint( x, y );
	}

	public function sub( b : MatPoint ) : MatPoint
	{
		return new MatPoint( x - b.x, y - b.y );
	}
	
	public function add( b : MatPoint ) : MatPoint
	{
		return new MatPoint( x + b.x, y + b.y );
	}
	
	public function promoteF( ) : MatPointF
	{
		return MatPointF.at( x, y );
	}
	
	/** 
	 * Promotes to MatPointF but aligns to the center
	 * of the logical space rather than the floor.
	 */
	public function promoteCtrF( ) : MatPointF
	{
		return MatPointF.at( x + 0.5, y + 0.5 );
	}
	
}
