package mathx;

class MatPointF extends MPoint<Float>
{
	private function new( ax : Float, ay : Float )
	{
		x = ax;
		y = ay;
	}
	
	static public function at( ax : Float, ay : Float) : MatPointF
	{
		return new MatPointF( ax, ay );
	}
	
	public function copy() : MatPointF
	{
		return new MatPointF( x, y );
	}

	public function sub( b : MatPointF ) : MatPointF
	{
		return new MatPointF( x - b.x, y - b.y );
	}
	
	public function add( b : MatPointF ) : MatPointF
	{
		return new MatPointF( x + b.x, y + b.y );
	}
	
	public function mul( c : Float ) : MatPointF
	{
		return new MatPointF( x * c, y * c );
	}
	
	public function div( c : Float ) : MatPointF
	{
		return new MatPointF( x / c, y / c );
	}
	
	public function midTo( b : MatPointF ) : MatPointF
	{
		return new MatPointF( (b.x -x)/2+x, (b.y-y)/2+y );
	}
	
	public function floorDemote() : MatPoint
	{
		return MatPoint.at( Math.floor( x ), Math.floor( y ) );
	}
	
	public function ceilDemote() : MatPoint
	{
		return MatPoint.at( Math.ceil( x ), Math.ceil( y ) );
	}
}
