package mathx;

/**
 * Adding missing math functions, mainly ported from ssim/math.h
 */
class MathUtil
{
	//TODO: Cleanup for haxe targets to actually expected types
	//these are expected to be used in comparison with other values,
	//on their own they don't have meaning...
	//private static var ZEROFACTOR : Float = 5e-17;	//must be from 80bit...
	private static var ZEROFACTOR : Float = 1e-7;	//for 32bit? (what horrible precision they have!!!)
	
	private static var NEARZEROFACTOR : Float = ZEROFACTOR * 1e6;

	//overkill on precision since I don't know the targets
	public static var PI : Float = 3.14159265358979323846;
	
	/**
	 * Returns true if both variables are equivalent within a factor
	 * of ZEROFACTOR
	 */
	public static function equals( x : Float, y : Float ) : Bool
	{
		// Use <= in the odd case of exact 0's
		if( x == 0 )	//in the case where x really is 100% 0!
			return Math.abs( x - y ) <= Math.abs( y ) * ZEROFACTOR;
		
		return Math.abs( x - y ) <= Math.abs( x ) * ZEROFACTOR;
		
	}
	
	/**
	 * Converts radians to degrees
	 */
	public static function radDeg( x : Float ) : Float
	{
		return x * 57.2957795;	//180 / PI;
	}	 
	
	/**
	 * Performs a square
	 */
	public static function sqr( x : Float ) : Float
	{
		return x*x;
	}
}
