package mathx.test;

import mathx.Tracer;
import flash.display.Sprite;
import fortress.MapLoader;
import mathx.Matrix;
import mathx.MatPoint;
import mathx.MatPointF;
import mathx.MatrixUtil;
import flash.events.MouseEvent;
import flash.events.Event;

class TraceTest extends Sprite
{
	static public var colors : Array<Int> = [ 0x000000, 0x000080, 0x008000 ];
	var traces : Array<Sprite>;
	
	var t : Tracer;
	
	static var scale : Float = 15;
	
	public function new()
	{
		super();
		addEventListener( Event.ADDED, onAdded );
	}
	
	function onAdded( evt : Event )
	{
		if( evt.target != this )
			return;
		
		var map = MapLoader.getLandMap( 0 );
		for( mp in map.xOrderIter() )
		{
			graphics.beginFill( colors[map.get( mp.x, mp.y )] );
			graphics.drawRect( scale * mp.x, scale * mp.y, scale, scale );
			graphics.endFill();
		}
		
		var s = flash.Lib.getTimer();
		t = new Tracer( map );
		//t = new Tracer( map );
		//t = new Tracer( map );
		//t = new Tracer( map );
		//t = new Tracer( map );
		var e = flash.Lib.getTimer();
		
		traces = new Array<Sprite>();
		for( i in 0...t.traces.length )
		{	
			var tr = t.traces[i];
			var sub = new Sprite();
			
			sub.graphics.beginFill( 0xff00ff );
			sub.graphics.drawEllipse( tr[0].x * scale-2, tr[0].y * scale-2,5,5 );
			sub.graphics.endFill();
			
			sub.graphics.moveTo( tr[0].x * scale, tr[0].y * scale );
			for( j in 1...tr.length )
			{
				if( j == 1 )
					sub.graphics.lineStyle( 2, 0xff00ff );
				else
					sub.graphics.lineStyle( 1, 0xff00ff );
				sub.graphics.lineTo( tr[j].x * scale, tr[j].y * scale );
			}
				
			//background (use original above instead...
			/*sub.graphics.beginFill( colors[t.tracesColor[i]] );
			sub.graphics.moveTo( tr[0].x * 15, tr[0].y * 15 );
			for( i in 1...tr.length )
				sub.graphics.lineTo( tr[i].x * 15, tr[i].y * 15 );
			sub.graphics.endFill();*/
				
			sub.visible = false;
			addChild( sub );
			traces.push( sub );
		}
		
		trace( e - s );
		addEventListener( MouseEvent.MOUSE_MOVE, onMouseMove );
	}

	function onMouseMove( evt : MouseEvent )
	{
		for( s in traces )
			s.visible = false;
			
		var mp = MatPointF.at( evt.localX/scale, evt.localY/scale ).floorDemote();
		if( t.traced.validIndex( mp.x, mp.y ) )
		{
			traces[t.traced.get( mp.x, mp.y )-1].visible = true;
		}
		
		evt.updateAfterEvent();
	}
	
	static public function main()
	{
		//none of these fucking modes work as described!!!
		flash.Lib.current.stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
		flash.Lib.current.stage.align = flash.display.StageAlign.TOP_LEFT;
		flash.Lib.current.addChild( new TraceTest() );
	}
}