package test;

import RangeIterI;
import RangeIterF;

class RangeIterTest extends haxe.unit.TestCase
{
	public function testForward()
	{
		var q = new RangeIterI( 5, 6 );
		assertTrue( q.hasNext() );
		assertEquals( q.next(), 5 );
		assertTrue( q.hasNext() );
		assertEquals( q.next(), 6 );
		assertFalse( q.hasNext() );
		
		q = new RangeIterI( 10, 13, 2 );
		assertEquals( 10, q.next() );
		assertEquals( 12, q.next() );
		assertFalse( q.hasNext() );	//overshoot
	}
	
	public function testBackward()
	{
		var q = new RangeIterF( 4, 3 );
		assertTrue( q.hasNext() );
		assertEquals( 4.0, q.next() );
		assertTrue( q.hasNext() );
		assertEquals( 3.0, q.next() );
		assertFalse( q.hasNext() );
		
		//must use somethign with exact float rep here to test
		q = new RangeIterF( 4, 3, -0.5 );
		assertEquals( 4.0, q.next() );
		assertEquals( 3.5, q.next() );
		assertEquals( 3.0, q.next() );
	}
	
	public function testSingle()
	{
		var q = new RangeIterI( 4, 4 );
		assertEquals( 4, q.next() );
		assertFalse( q.hasNext() );
	}
}
