package ui;

class CircularProgress extends AnimatedWidget
{
	var total : Float;
	var current : Float;
	var color : Int;
	
	//TODO: Create interface for adjusting
	var penSize : Float;	//factor of width/height
	var fillSize : Float;	//how much of space to consume
	
	var angle : Float;	//current angle of animation
	
	public function new( color : Int )
	{
		super();
		
		penSize = 0.03;
		fillSize = 0.8;
		
		total = 1;
		current = 0;
		this.color = color;
		
		angle = 0;
	}
	
	function _animate( elapsed : Float )
	{
		angle += elapsed * 4;
		update();
	}
	
	public function setTotal( total : Float )
	{
		this.total = total;
		update();
	}
	
	public function setCurrent( current : Float )
	{
		this.current = current;
		update();
	}
	
	public function getCurrent( ) : Float 
	{
		return current;
	}
	
	function _resize( w : Float, h : Float )
	{
		graphics.clear();
		
		var range = (this.current / this.total) * Math.PI;	//*2 / 2 (For half)
		
		var cx = w/2;
		var cy = h/2;
		
		var nw = w * fillSize;
		var nh = h * fillSize;
		
		var uPenSize = penSize * (w+h) / 2;
		graphics.lineStyle( uPenSize, ColorUtil.brighten( color ) );
		GraphicsUtil.drawArc( graphics, 
			w/2, h/2, w/2.5, h/2.5, 
			angle - range, angle + range, 
			false );
		
		graphics.lineStyle( uPenSize, ColorUtil.darken( color ) );
		GraphicsUtil.drawArc( graphics, 
			w/2, h/2, w/2.5-uPenSize, h/2.5-uPenSize, 
			Math.PI-(angle-range), Math.PI- (angle + range), 
			false );
	}
}
