package ui;

import flash.events.Event;

class EditText extends StaticText
{
	var border : SimpleBox;
	
	public function new( ?maxlength : Null<Int>, ?align : StaticTextAlign )
	{
		super( '', align );
		tf.selectable = true;
		tf.type = flash.text.TextFieldType.INPUT;
		if( maxlength != null )
			tf.maxChars = maxlength;
			
		tf.addEventListener( Event.CHANGE, onChanged );
		
		border = new SimpleBox( Pen.solid( 1, 0x000000 ) );
		addChild( border );
	}
	
	function _resize( w : Float, h : Float )
	{
		//disable editing if not enabled
		tf.type = enabled ? flash.text.TextFieldType.INPUT : flash.text.TextFieldType.DYNAMIC;
		
		super._resize( w, h );
		if( border != null )
			border.resize( w, h );
	}
	
	function onChanged( evt : Event )
	{
		//mainly for case from length 0 to something, the text needs to be resized..
		update();
	}
}
