package ui;

import flash.events.Event;

/**
 * A generic event for menu items.
 *
 * The constructor allows both the standard type and a dynamic extension.
 * This extension is simply held by the MenuEvent and available in the
 * handler.  This allows you to use one "type" with multiple dynamic items
 * to avoid needing several handlers (as often some menu items call the
 * same procedure with only slightly different parameters)
 */
class MenuEvent extends Event
{
	public var ext : Dynamic;	//an extension object
	
	public function new( evtStr : String, ?aext : Dynamic )
	{
		super( evtStr, true );	//bubbles by default
		ext = aext;
	}
	
	//haxe Bug prevents overriding of clone... so for now we use a custom
	//solution with the Popup manager also recognizing this
	public function fixClone( ) : Event
	{
		return new MenuEvent( type, ext );
	}
}
