package ui;

import flash.display.Graphics;

enum PenType
{
	None;
	Solid( color : Int, alpha : Float );
}

/**
 * Creates a logical pen which can be used for outlined drawn objects
 */
class Pen
{
	var type : PenType;
	var width : Float;
	
	private function new( width : Float, pt : PenType )
	{
		type = pt;
		this.width = width;
	}
	
	public function isNonEmpty() : Bool
	{
		return type != None;
	}
	
	public function apply( graphics : Graphics )
	{
		switch( type )
		{
			case None:
				graphics.lineStyle();
			case Solid( color, alpha ):
				graphics.lineStyle( width, color, alpha );
		}
	}
	
	static public function empty() : Pen
	{
		return new Pen( 0, PenType.None );
	}
	
	static public function solid( width : Float, color : Int, ?alpha : Float ) : Pen
	{
		if( alpha == null )
			alpha = 1;
			
		return new Pen( width, PenType.Solid( color, alpha ) );
	}
}