package ui;

/**
 * Determines how the object will be sized in the layout.
 * Primary is the dimension of the layout (in Vertical this is the height, Horizontal the width)
 * Secondary is the alternate dimension
 */
enum SizeType
{
	Hidden;	//the item should not be displayed
	
	//usable as override or preferred size
	Fixed( size : Float );	//a fixed size, secondary dimension resizes only
	FixedFunc( func : Void -> Float );	//call the function to get the size
	FixedFunc1( func : Float -> Float, param : Float );	//call the function (with param) to get the size
	Lines( num : Float );	//number of lines in the used font
	XWidth( num : Float );	//number of column widths as defined by x width in font	
	Ratio( xy : Float );	//the ratio of x/y, usually with a full size in the secondary dimension
	
	//always relevant?
	Fill( weight : Float );	//fill to remaining size with given weight
	
	Sum( a : SizeType, b : SizeType );	//the sum of two other size-types
	Max( a : SizeType, b : SizeType );	//the greater of the two sizes
}
