package ui;

import flash.display.Sprite;
import flash.events.Event;
import flash.display.DisplayObject;

/**
 * A common base class for Flash targets which sets up a common stage
 * environment for a dynamically sized application.
 */
class StageLayout extends Sprite
{
	public function new( ?size : mathx.MatPoint )
	{
		super();
		
		if( size == null )
			size = mathx.MatPoint.at( 80, 40 );
			
		AnimationManager.init( 30 );	//a default frame speed
		FontManager.init( size.x, size.y );	//standard text layout
		addEventListener( Event.ADDED, onAdded, false, 0, true /*weak*/ );
	}
	
	 function onAdded( evt : Event )
	{
		if( evt.target != this )
			return;
			
		stage.addEventListener( Event.RESIZE, onResize, false, 0, true /*weak*/ );
		
		added();
		resize( stage.stageWidth, stage.stageHeight );
	}
	
	//called when added to the real stage
	function added()
	{
		//need not be overridden
	}
	
	function onResize( evt : Event )
	{
		resize( stage.stageWidth, stage.stageHeight );
	}
	
	//called whenever the stage is resized
	function resize( w : Float, h : Float )
	{
		//must be overridden (or this base is pointless)
		Assert.pureVirtual();
	}
	
	//Does a standard setup with the core object given (need not be STageLayout, but then what would be the point)
	static function setup( core : DisplayObject )
	{
		flash.Lib.current.stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
		flash.Lib.current.stage.align = flash.display.StageAlign.TOP_LEFT;
		flash.Lib.current.addChild( core );
	}
}
