package ui;

/**
 * The base class used by our layout items.  It adds needed missing items
 * to the DisplayObject from Flash, it also serves as a useful abstraction
 * from the Flash layer (though with getNative used often this isn't much
 * of an abstraction).
 */
interface Widget
{
	public function move( x : Float, y : Float ) : Void;
	public function resize( w : Float, h : Float ) : Void;
	public function update( ) : Void;
	
	/**
	 * Obtains the preferred width for the widget.
	 */
	public function getPrefWidth() : SizeType;
	public function getPrefHeight() : SizeType;
	
	/**
	 * Enables or disables the Widget.  For input widgets this should prevent
	 * entry, and for other widgets perhaps graying them out, as though they
	 * were part of a input control
	 */
	public function enable( set : Bool ) : Void;
	
	public function getNative() : flash.display.DisplayObjectContainer;	//to be compatible with Window
}
