package ui.test;

import flash.display.Sprite;

import ui.SimpleBox;
import ui.LinearLayout;
import ui.StaticText;
import ui.Brush;

class LayoutTest extends ui.StageLayout
{
	var vl  : LinearLayout;
	
	function new()
	{
		var m = ui.LayoutDirection.Horizontal;
		var n = ui.LayoutDirection.Vertical;
		
		super();
		vl = new LinearLayout( m );
		
		var vl1 = new LinearLayout( n );
		vl1.setBackground( new SimpleBox( Brush.solid(0x800000) ) );
		vl.add( vl1, ui.SizeType.Fill( 1 ) );
		
		var vl2 = new LinearLayout( n );
		vl2.setBackground( new SimpleBox( Brush.solid(0x008000) ) );
		vl.add( vl2, ui.SizeType.Fill( 1 ) );
		
		var vl3 = new LinearLayout( n );
		vl.add( vl3, ui.SizeType.Fill( 1 ) );
		
		for( i in 0...5 )
		{
			if( i %2 == 0 )
			{
				var color = Math.floor( Math.random() * 0xffffff );
				vl1.add( new SimpleBox( Brush.solid(color) ), ui.SizeType.Fixed( 10 ) );
				vl2.add( new SimpleBox( Brush.solid(color) ), ui.SizeType.Fill( i + 1 ) );
				vl3.add( new SimpleBox( Brush.solid(color) ), ui.SizeType.PRelative( 0.1 ) );
			}
			else
			{
				vl1.add( new StaticText( "Item " + i ), ui.SizeType.Fixed( 10 ) );
				vl2.add( new StaticText( "Item " + i ), ui.SizeType.Fill( i + 1 ) );
				vl3.add( new StaticText( "Item " + i ), ui.SizeType.PRelative( 0.1 ) );
			}
		}
		
		vl1.add( new SimpleBox(Brush.solid(0) ), ui.SizeType.Ratio( 0.5 ) );
		vl2.add( new SimpleBox(Brush.solid(0) ), ui.SizeType.Ratio( 0.1 ) );
		vl3.add( new SimpleBox(Brush.solid(0) ), ui.SizeType.Fixed( 10 ) );
		
		//test adding background after other children
		vl3.setBackground( new SimpleBox( Brush.solid(0) ) );
		
		addChild( vl );
	}
	
	function resize( w : Float, h : Float )
	{	
		vl.resize( w, h );
	}
	
	static public function main()
	{
		ui.StageLayout.setup( new LayoutTest() );
	}
}
