package ui.test;

import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.Event;
import flash.events.KeyboardEvent;

import ui.Modal;
import ui.Popup;
import ui.MenuEvent;
import ui.LinearLayout;
import ui.Button;
import ui.Action;
import ui.CheckBox;
import ui.StaticText;
import ui.RadioGroup;
import ui.RadioBox;
import ui.FontManager;
import ui.GridLayout;

class DialogTest extends ui.Dialog
{
	public function new()
	{
		var columns = new LinearLayout( ui.LayoutDirection.Horizontal );
		
		var col1 = new LinearLayout( ui.LayoutDirection.Vertical );
		columns.add( col1, ui.SizeType.Fill( 1 ) );
		col1.add( new StaticText( "Check Boxes" ), ui.SizeType.FixedFunc1( FontManager.getDefault().byLines, 1  ) );
		col1.add( new CheckBox( "Check me" ), ui.SizeType.FixedFunc1( FontManager.getDefault().byLines, 1  ) );
		col1.add( new CheckBox( "Also me" ), ui.SizeType.FixedFunc1( FontManager.getDefault().byLines, 1  ) );
		
		var col2 = new LinearLayout( ui.LayoutDirection.Vertical );
		columns.add( col2, ui.SizeType.Fill( 1 ) );
		var tf2 = new StaticText( "Radios" );
		tf2.bold = true;
		col2.add( tf2, ui.SizeType.FixedFunc1( FontManager.getDefault().byLines, 1  ) );
		
		var rg = new RadioGroup();
		for( i in 0...5 )
		{
			var r = new RadioBox( "Item " + i );
			col2.add( r, ui.SizeType.FixedFunc1( FontManager.getDefault().byLines, 1  ) );
			rg.manage( r );
		}
		
		//add a sample table
		var table = new GridLayout( 4, 3 );
		col1.add( table, ui.SizeType.FixedFunc1( FontManager.getDefault().byLines, 4  ) );
		for( x in 0...4 )
			for( y in 0...3 )
				table.setItem( x, y, new StaticText( x + "," + y ) );
		
		super( "A Sample Dialog", columns );
	}
}

/**
 * Click or press "Space" to activate the popup menu
 */
class MenuTest extends ui.StageLayout
{
	private var popup : Popup;
	private var back : Sprite;
	var buttonBar : LinearLayout;
			
	public function new()
	{
		super();
		
		addEventListener( MouseEvent.MOUSE_DOWN, onMouseDown );
		
		var o = new Popup();
		o.addItem( "Popup 2-1" , new MenuEvent( "l_onPopup2", 1 ) );
		o.addItem( "Popup 2-2" , new MenuEvent( "l_onPopup2", 2 ) );
		o.addItem( "Popup 2-3" , Action.bind1( onMenuF, 3 ) );
		
		var n = new Popup();
		n.addItem( "Popup 2-1" , new MenuEvent( "l_onPopup2", 1 ) );
		n.addItem( "Popup 2-2" , new MenuEvent( "l_onPopup2", 2 ) );
		n.addItem( "Popup 2-3" , Action.bind1( onMenuF, 3 ) );
		
		var p = new Popup();
		p.addSubMenu( "Deeper...", o );
		p.addSeparator();
		p.addItem( "Popup 1" , new MenuEvent( "l_onPopup1", "Happy" ) );
		p.addItem( "Popup 2" , new MenuEvent( "l_onPopup1", "Go" ) );
		p.addItem( "Popup 3", Action.bind1( onMenuF, "Lucky" ) );
		p.addSeparator();
		p.addSubMenu( "Another...", n );
		
		popup = new Popup();
		popup.addItem( "First", "l_onMenuFirst" );
		popup.addItem( "Dialog", "l_onDialog" );
		popup.addSeparator();
		popup.addSubMenu( "Third", p );
		popup.addSeparator();
		popup.addItem( "Fourth Item", Action.bind( function() { trace("l_onMenuFourth"); } ) );
		popup.addSubMenu( "(Repeat) Deeper...", o );
		
		
		addEventListener( "l_onMenuFirst", onMenu );
		addEventListener( "l_onDialog", onDialog );
		addEventListener( "l_onMenuThird", onMenu );
		
		addEventListener( "l_onPopup1", onMenu );
		addEventListener( "l_onPopup2", onMenu );
		
		
		back = new Sprite();
		addChild( back );
		
		//simple sprite loading... (in independe player the load seems synchronous)
//#if nothing	//don't do by default since standalone player loads synchronously, blocking everything!
		var sp = new ui.URLSprite( "http://www.google.com/intl/en_ALL/images/logo.gif" );
		sp.x = 100;
		sp.resize( 50, 50 );
		addChild( sp );
		
		sp = new ui.URLSprite( "http://www.google.com/intl/en_ALL/images/broken.logo.gif" );
		sp.x = 100;
		sp.y = 100;
		sp.resize( 50, 50 );
		addChild( sp );
//#end
		
		buttonBar = new LinearLayout( ui.LayoutDirection.Vertical );
		addChild( buttonBar );
		
		buttonBar.add( 
			new Button( "Dialog", "l_onDialog" ), 
			ui.SizeType.Fill( 1 ) 
			);
		buttonBar.add( 
			new Button( "Button Two", new MenuEvent("b_button","Two") ),
			ui.SizeType.Fill( 1 ) 
			);
		buttonBar.add( 
			new Button( 
				"Three", 
				Action.bind( function() { trace("b_onButtonThree"); } ) ),
			ui.SizeType.Fill( 2 ) 
			);
		buttonBar.add( 
			new Button( "One Again", "b_button" ), 
			ui.SizeType.Fill( 1 ) 
			);
		
		addEventListener( "b_button", onButton );
		
		dialog = new DialogTest();
		dialog.addAction( "Okay", "xOkay" );
		dialog.addAction( "Cancel", "xCancel" );
	}
	
	var dialog : DialogTest;
	
	function onDialog( evt : MenuEvent )
	{
		trace( "MODAL" );
		var m = new Modal();
		m.setCompletionAction( Action.bind( dialogDone ) );
		m.exec( this, dialog );
	}
	
	function dialogDone()
	{
		trace( "Dialog: " + dialog.actionFinish );
	}
	
	private function added( )
	{
		stage.addEventListener( KeyboardEvent.KEY_UP, onKeyUp );
	}
	
	private function resize( w : Float, h : Float )
	{
		back.graphics.beginFill( 0x40A080 );
		back.graphics.drawRect( 0, 0, w, h );
		back.graphics.endFill();
		
		//add a background object to show graying
		back.graphics.beginFill( 0xA00080 );
		back.graphics.drawEllipse( w/3, h/3, 2*w/3, 2*h/3 );
		back.graphics.endFill();
		
		buttonBar.x = w/3;
		buttonBar.y = h/4;
		buttonBar.resize( w/3, h/2 );
		
		dialog.move( w/6, h/6);
		dialog.resize( 2*w/3, 2*h/3 );
	}
	
	private function onMenuF( param :Dynamic )
	{
		trace( "onMenuF with " + param );
	}
	
	private function onMenu( evt : MenuEvent )
	{
		if( evt.ext != null )
			trace( evt.type + " with " + evt.ext );
		else
			trace( evt.type );
	}
	
	private function onButton( evt : MenuEvent )
	{
		if( evt.ext != null )
			trace( "Button: " + evt.type + " with " + evt.ext );
		else
			trace( "Button: " + evt.type );
	}
	
	private function onMouseDown( evt : MouseEvent ) 
	{
		if( evt.target == back )
		{
			popup.x = evt.stageX;
			popup.y = evt.stageY;
			
			if( evt.ctrlKey )
			{
				trace( "MODAL" );
				var m = new Modal();
				m.setCompletionAction( Action.bind( modalDone ) );
				m.exec( this, popup );
			}
			else
				popup.go( this );
		}
	}
	
	function modalDone()
	{
		trace( "Modal Done" );
	}
	
	private function onKeyUp( evt : KeyboardEvent )
	{
		if( evt.keyCode == flash.ui.Keyboard.SPACE )
		{
			popup.x = mouseX;
			popup.y = mouseY;
			popup.go( this );
			evt.updateAfterEvent();
		}
	}
	
    static function main() {
		ui.StageLayout.setup( new MenuTest() );
	}

}
