package ui.test;

import ui.AnimatedWidget;
import ui.CircularProgress;

class ProgressTester extends AnimatedWidget
{
	var progress : CircularProgress;
	
	public function new()
	{
		super();
		
		progress = new CircularProgress( 0x00a000 );
		progress.setTotal( 10 );		
		addChild( progress );
	}
	
	function _animate( elapsed : Float ) 
	{
		progress.setCurrent( progress.getCurrent() + elapsed );
	}
	
	function _resize( w : Float, h : Float )
	{
		progress.resize( w, h );
	}
}

class TestAnimation extends ui.StageLayout
{
	var ch : AnimatedWidget;
	
	public function new()
	{
		super();
		
		ch = new ProgressTester();
		addChild( ch );
	}

	function resize( w : Float, h : Float )
	{
		ch.resize( w, h );
	}
	
	static public function main()
	{
		ui.StageLayout.setup( new TestAnimation() );
	}
}
